/*************************************************************************************
*  Copyright (c) 1997-1998 by Joseph Parrello. All Rights Reserved.                  *
*  Site   : http://space.tin.it/computer/giparrel                                    *
*  E-Mail : joparrel@tin.it, giusparr@tin.it, giparre@tin.it                         *
*                                                                                    *
*  Revision:   1.1a  (April 3, 1998).                                                *
*                                                                                    *
*  Definition of JPFlatMenuButtonGadget class.                                       *
*                                                                                    *
*  Read JPFLMEBU.TXT for use and license.                                            *
*                                                                                    *
*  Only for OWL 5.02 and 5.01 users.                                                 *
*  OWL and ObjectWindows are trademarks of Borland International.                    *
*                                                                                    *
*  THIS CLASS AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF                *
*  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO               *
*  THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A                    *
*  PARTICULAR PURPOSE.                                                               *
*************************************************************************************/
#include <owl/pch.h>

#include "jpflmebu.h"


//{{JPFlatMenuButtonGadget Implementation}}

JPFlatMenuButtonGadget::JPFlatMenuButtonGadget(TMenu& menu, TResId glyphResIdOrIndex, int id, TType type, bool enabled, TState state, bool sharedGlyph)
:
    JPFlatButtonGadget(glyphResIdOrIndex, id, type, enabled, state, sharedGlyph)
{
  // INSERT>> Your constructor code here.
  GadgetPopupMenu = new TPopupMenu(menu);
}


JPFlatMenuButtonGadget::~JPFlatMenuButtonGadget()
{
  // INSERT>> Your destructor code here.
  delete GadgetPopupMenu;
}


void JPFlatMenuButtonGadget::BeginPressed(TPoint& p)
{
  HWND ParentWnd;

  JPFlatButtonGadget::BeginPressed(p);

  // INSERT>> Your code here.
   TWindow* parent= Window->GetParentO();
   TDecoratedFrame* frame= parent ?
                           TYPESAFE_DOWNCAST(parent, TDecoratedFrame) : 0;
   while (parent && !frame)
   {
     parent = parent->GetParentO();
     if (parent)
       frame = TYPESAFE_DOWNCAST(parent, TDecoratedFrame);
   }
   if (frame)
   	ParentWnd = *frame;
   else ParentWnd = NULL;
  if (ParentWnd)
     {
  		if (Window->GetHintMode() == TGadgetWindow::EnterHints)
    		Window->SetHintCommand(-1);
      TRect rect = GetBounds();
      TPoint p2(rect.TopLeft());
      Window->ClientToScreen(p2);
      rect.right = p2.x + (rect.right - rect.left);
      rect.bottom = p2.y + (rect.bottom - rect.top);
      rect.left = p2.x;
      rect.top = p2.y;
      p2.y = rect.bottom;
      #if defined(BI_PLAT_WIN16)
      GadgetPopupMenu->TrackPopupMenu(TPM_LEFTALIGN | TPM_LEFTBUTTON, p2, 0, ParentWnd);
      #elif defined(BI_PLAT_WIN32)
      TrackPopupMenuEx(TPM_VERTICAL, p2, ParentWnd, &rect);
      #endif
      CancelPressed(p);
      LButtonUp(0,p);
      }
}

#if defined(BI_PLAT_WIN32)
bool JPFlatMenuButtonGadget::TrackPopupMenuEx(uint flags, const TPoint& point, HWND wnd, const TRect* rect)
{
  TPMPARAMS tpm;

  PRECONDITION(GadgetPopupMenu->GetHandle());
  tpm.cbSize=sizeof(TPMPARAMS);
  tpm.rcExclude=*rect;
  return ::TrackPopupMenuEx(GadgetPopupMenu->GetHandle(), flags, point.x, point.y, wnd, &tpm);
}
#endif

