/*************************************************************************************
*  Copyright (c) 1997-1998 by Joseph Parrello. All Rights Reserved.                  *
*  Site   : http://space.tin.it/computer/giparrel                                    *
*  E-Mail : joparrel@tin.it, giusparr@tin.it, giparre@tin.it                         *
*                                                                                    *
*  Revision:   1.1a  (April 3, 1998).                                                *
*                                                                                    *
*  Definition of JPFlatMenuButtonGadget class.                                       *
*                                                                                    *
*  Read JPFLMEBU.TXT for use and license.                                            *
*                                                                                    *
*  Only for OWL 5.02 and 5.01 users.                                                 *
*  OWL and ObjectWindows are trademarks of Borland International.                    *
*                                                                                    *
*  THIS CLASS AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF                *
*  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO               *
*  THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A                    *
*  PARTICULAR PURPOSE.                                                               *
*************************************************************************************/

#if !defined(jpmbutga_h)
#define jpmbutga_h

#if !defined(OWL_MENU_H)
# include <owl/menu.h>
#endif
#if !defined(OWL_GADGETWI_H)
#include <owl/gadgetwi.h>
#endif
#include "jpfltbtg.h"

//{{JPFlatButtonGadget = JPFlatMenuButtonGadget}}
class JPFlatMenuButtonGadget : public JPFlatButtonGadget {
  public:
    JPFlatMenuButtonGadget(TMenu& menu, TResId glyphResIdOrIndex, int id, TType type = Command, bool enabled = true, TState state = Up, bool sharedGlyph = false);
    virtual ~JPFlatMenuButtonGadget();

  private:
    TPopupMenu*         GadgetPopupMenu;
#if defined(BI_PLAT_WIN32)
    bool                TrackPopupMenuEx(uint flags, const TPoint& point, HWND wnd, const TRect* rect);
#endif

//{{JPFlatMenuButtonGadgetVIRTUAL_BEGIN}}
  public:
    virtual void BeginPressed(TPoint& p);
//{{JPFlatMenuButtonGadgetVIRTUAL_END}}
};    //{{JPFlatMenuButtonGadget}}

#endif
